--Require collision library.
HC = require "hardoncollider"

function love.load()
	--Start the collision library.
	collider = HC(100, on_collision, collision_stop);

	player = {
		x = 14,
		y = 14,
		w = 20,
		h = 20,
		speed = 100
	}
	
	post = {
		x = 192,
		y = 192
	}
	
	player_bounding_box = collider:addCircle(player.x, player.y, 10);
	post_bounding_box = collider:addRectangle(post.x, post.y, 64, 64);
	--Comment the bottom line to see things fixed magically
	extra_bounding_box = collider:addCircle(400, 200, 30);
end

function love.update(dt)
	collider:update(dt)

	if love.keyboard.isDown("d") then
		player.x = player.x + (player.speed * dt);
		player_bounding_box:move(player.speed * dt, 0);
	elseif love.keyboard.isDown("a") then
		player.x = player.x - (player.speed * dt);
		player_bounding_box:move(-player.speed * dt, 0);
	end	
	
	if  love.keyboard.isDown("w") then
		player.y = player.y - (player.speed * dt);
		player_bounding_box:move(0, -player.speed * dt);
	elseif love.keyboard.isDown("s") then
		player.y = player.y + (player.speed * dt);
		player_bounding_box:move(0, player.speed * dt);
	end
end

function love.draw()
	player_bounding_box:draw("line");
	post_bounding_box:draw("line");
	--Might as well comment this line too.
	extra_bounding_box:draw("line");
end

function on_collision(dt, shape_a, shape_b, mtv_x, mtv_y)
	local player_shape, post_shape
	if shape_a == player_bounding_box and shape_b == post_bounding_box then
		player_shape = shape_a
		player_collide_with_post(player_shape, mtv_x, mtv_y);
	elseif shape_b == player_bounding_box and shape_a == post_bounding_box then
		player_shape = shape_b
		player_collide_with_post(player_shape, mtv_x, mtv_y);
	end
end

function player_collide_with_post(player_shape, mtv_x, mtv_y)
	player_shape:move(mtv_x, 0);
	player_shape:move(0, mtv_y);
	player.x = player.x + mtv_x;
	player.y = player.y + mtv_y;
end